#include <stdlib.h>
#include <stdio.h>
#include "openglheader.h" /* najpierw ten */
#include <GL/freeglut.h>  /* potem ten */

#include "utilities.h"
#include "app1.h"

int WindowHandle;

int option = 2;
int opti = 0;

void ReshapeFunc ( int width, int height )
{
  GLfloat m[16];
  float lr;

  glViewport ( 0, 0, width, height );  /* klatka jest calym oknem */
  lr = 0.5533*(float)width/(float)height;
  M4x4Frustumf ( m, NULL, -lr, lr, -0.5533, 0.5533, 5.0, 15.0 );
  glBindBuffer ( GL_UNIFORM_BUFFER, trbuf );
  glBufferSubData ( GL_UNIFORM_BUFFER, trbofs[2], 16*sizeof(GLfloat), m );
  opti = 4;
  ExitIfGLError ( "ReshapeFunc" );
} /*ReshapeFunc*/

void DisplayFunc ( void )
{
  if ( opti > 0 ) {
    opti --;
    glutPostWindowRedisplay ( WindowHandle );
  }
  else {
    glClearColor ( 1.0, 1.0, 1.0, 1.0 );
    glClear ( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    glEnable ( GL_DEPTH_TEST );
    DrawIcosahedron ( option );
    glFlush ();
  }
  glutSwapBuffers ();
} /*DisplayFunc*/

void KeyboardFunc ( unsigned char key, int x, int y )
{
  switch ( key ) {
case 0x1B:            /* klawisz Esc - zatrzymanie programu */
    Cleanup ();
    glutLeaveMainLoop ();
    break;
case 'W':  case 'w':  /* przelaczamy na wierzcholki */
    option = 0;
    glutPostWindowRedisplay ( WindowHandle );
    break;
case 'K':  case 'k':  /* przelaczamy na krawedzie */
    option = 1;
    glutPostWindowRedisplay ( WindowHandle );
    break;
case 'S':  case 's':  /* przelaczamy na sciany */
    option = 2;
    glutPostWindowRedisplay ( WindowHandle );
    break;
default:              /* ignorujemy wszystkie inne klawisze */ 
    break;
  }
} /*KeyboardFunc*/

void MouseFunc ( int button, int state, int x, int y ) {  }
void MotionFunc ( int x, int y ) {  }
void JoystickFunc ( unsigned int buttonmask, int x, int y, int z ) { }
void TimerFunc ( int value ) {  }
void IdleFunc ( void ) {  }

void Initialise ( int argc, char *argv[] )
{
  glutInit ( &argc, argv );
  glutInitContextVersion ( 2, 1 );
  glutInitContextFlags ( GLUT_FORWARD_COMPATIBLE );
  glutInitContextProfile ( GLUT_CORE_PROFILE );
  glutSetOption ( GLUT_ACTION_ON_WINDOW_CLOSE,
                  GLUT_ACTION_GLUTMAINLOOP_RETURNS );
  glutInitWindowSize ( 480, 360 );
  glutInitDisplayMode ( GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA );
  WindowHandle = glutCreateWindow ( "Pierwsza aplikacja" );
  if ( WindowHandle < 1 ) {
    fprintf ( stderr, "Error: Could not create a window\n" );
    exit ( 1 );
  }
  glutReshapeFunc ( ReshapeFunc );
  glutDisplayFunc ( DisplayFunc );
  glutKeyboardFunc ( KeyboardFunc );
  glutMouseFunc ( MouseFunc );
  glutMotionFunc ( MotionFunc );
  /*glutJoystickFunc ( JoystickFunc, 16 );*/
  /*glutTimerFunc ( 0, TimerFunc, 0 );*/
  /*glutIdleFunc ( IdleFunc );*/
  GetGLProcAddresses ();
#ifdef USE_GL3W
  if ( !gl3wIsSupported ( 4, 2 ) )
    ExitOnError ( "Initialise: OpenGL version 4.2 not supported\n" );
#endif
  LoadMyShaders ();
  InitMyObject ();
} /*Initialise*/

int main ( int argc, char *argv[] )
{
  Initialise ( argc, argv );
  glutMainLoop ();
  exit ( 0 );
} /*main*/
