
#define APP3_MAJOR     4
#define APP3_MINOR     5

#define WIN0_WIDTH   480
#define WIN0_HEIGHT  360
#define MENU_WIDTH   120

#define BTN_ID_EXIT    1
#define SW_ID_FACETS   2
#define SW_ID_EDGES    3
#define SW_ID_VERTICES 4
#define SW_ID_LIGHT    5
#define SW_ID_ANIMATE  6
#define SL_ID_SPEED    7

#define GLWIN_ID_VIEW  8

#define WDGSTATE_VIEW_TURNING    2
#define WDGSTATE_MODEL_ANIMATION 3

#define CLIENTMSG_ANIMATE        1

typedef struct {
          float left, right, top, bottom, near, far, rl, tb;
          float   viewer_rvec[4], viewer_rangle;
          float   speed;
          int     prevx, prevy;
          char    model_option;
          char    light_option;
          char    state, animation;
          GLfloat eyepos[4];
          GLfloat mm[16], vm[16], pm[16];
        } myglwindata;

typedef struct my3Dwidget {
    xwidget     wdg;
    void        (*redraw)(struct my3Dwidget *wdg);
  } my3Dwidget;

typedef void (*my3Dredraw)( my3Dwidget *wdg );

extern GLuint      trbuf;
extern GLint       trbofs[5];
extern my3Dwidget  *mywdg;
extern myglwindata myglwdata;

extern float   model_rot_axis[3], model_rot_angle0, model_rot_angle;

void LoadMyShaders ( void );
void DestroyMyShaders ( void );
void InitMyObject ( void );
void DestroyMyObject ( void );

void RotateViewer ( int delta_xi, int delta_eta );
void SetupMVPMatrix ( void );
void SetupModelMatrix ( float axis[3], float angle );
void DrawIcosahedron ( int opt, char enlight );

void ToggleAnimation ( myglwindata *wd, char on );

