#version 450 core

layout(triangles) in;
layout(triangle_strip,max_vertices=3) out;

in GVertex {
    vec4 Normal;
  } In[];

out NVertex {
    vec3 Position;
    vec3 snv, tnv;
  } Out;

uniform TransBlock {
    mat4 mm, mmti, vpm;
    vec4 eyepos;
  } trb;

uniform bool MeshNormals;

void main ( void )
{
  int  i;
  vec4 p[3];
  vec3 q[3], nv[3], v1, v2, tnv;

  for ( i = 0; i < 3; i++ ) {
    p[i] = trb.mm * gl_in[i].gl_Position;
    q[i] = p[i].xyz/p[i].w;
    nv[i] = normalize ( (trb.mmti * In[i].Normal).xyz );
  }
  v1 = q[1] - q[0];  v2 = q[2] - q[0];
  tnv = normalize ( cross ( v2, v1 ) );
  for ( i = 0; i < 3; i++ ) {
    gl_Position = trb.vpm * p[i];
    Out.Position = q[i];
    Out.tnv = tnv;
    if ( !MeshNormals || dot ( nv[i], nv[i] ) < 1.0e-10 )
      Out.snv = Out.tnv = tnv;
    else {
      Out.snv = nv[i];
      Out.tnv = dot ( nv[i], tnv ) > 0.0 ? tnv : -tnv;
    }
    EmitVertex ();
  }
  EndPrimitive ();
} /*main*/

