
#define MESHDEG        3
#define NPALMMESHES    4
#define NKLOBJ         1
#define NKLINKS       21
#define NKLREFS       17
#define NKLJOINTS     20
#define NKLARTPARAMS  20

typedef struct {
          char        meshsw[NPALMMESHES+1];
          char        lod;
          float       palmartp[NKLARTPARAMS];
          GPUmesh     *palms[NPALMMESHES+2];
          kl_linkage  *lkg;
        } mypalmscene;

typedef struct {
          float       left, right, top, bottom, near, far, rl, tb;
          int         prevx, prevy;
          float       viewer_rvec[4], viewer_rangle;
          GLfloat     eyepos[4];
          GLfloat     mm[16], mmti[16], vm[16], pm[16], vpm[16];
          float       speed, model_rot_angle0, model_rot_angle;
          char        animation;
        } myglwindata;

extern GLuint trbuf;
extern GLint  trbofs[4];

extern myglwindata myglwdata;
extern mypalmscene myscene;
extern float       model_rot_axis[3];
extern float       viewer_pos0[4];

void SetVPMatrix ( GLfloat vm[16], GLfloat pm[16], GLfloat ep[4] );
void SetupModelMatrix ( myglwindata *wd, float axis[3], float angle );
void InitViewMatrix ( myglwindata *wd );
char RotateViewer ( myglwindata *wd, float width, float height,
                    int delta_xi, int delta_eta );

void LoadMyShaders ( void );
void InitMyObject ( void );
void LoadMeshRenderingShaders ( void );
void DestroyMeshRenderingShaders ( void );
void DestroyMyObject ( void );
void DestroyMyShaders ( void );

void DrawMeshEdges ( GPUmesh *mesh, GLfloat colour[4] );
void DrawMeshFacets ( GPUmesh *mesh, GLfloat colour[4], char nvectors );

void DrawMyScene ( void );

void LoadLinkageArticulationShaders ( void );
void DestroyLinkageArticulationShaders ( void );
kl_linkage *ConstructPalmLinkage ( mypalmscene *scene );
void SetArticulationParameter ( mypalmscene *scene, int pnum );
void ArticulatePalmLinkage ( mypalmscene *scene );

